<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.waf.world_map_top_10' | translate}}</span>
          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['worldMapChart'].value"
                        (changeValue)="periodFilterChart.controls['worldMapChart'].setValue($event);loadWorldMapChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadAttackerCountryChart()" [formControl]="periodFilterChart.controls['worldMapChart']"-->
                    <!--name="period" class="form-control"-->
                    <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodCharts" [ngValue]="period">-->
                <!--{{period.label}}-->
              <!--</option>-->
            <!--</select>-->
          </div>
        </div>
        <div class="card-body p-0">
          <!--<app-world-chart-waf [data]="worldMapChart" *ngIf="worldMapChart"></app-world-chart-waf>-->
          <ng-world-map [data]="worldMapChart" *ngIf="worldMapChart"></ng-world-map>
        </div>
      </div>
    </div>

    <div class="col-lg-6">
      <div class="card">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.waf.world_chart_top_10_country' | translate}}</span>

          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['worldPieChart'].value"
                        (changeValue)="periodFilterChart.controls['worldPieChart'].setValue($event);loadAttackerCountryChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadAttackerCountryChart()" [formControl]="periodFilterChart.controls['worldPieChart']"-->
                    <!--name="period" class="form-control"-->
                    <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodCharts" [ngValue]="period">-->
                <!--{{period.label}}-->
              <!--</option>-->
            <!--</select>-->
          </div>


        </div>
        <div class="card-body" id="attackerCountryChart">
          <div class="chart-wrapper" *ngIf="attackerCountryChart">
            <canvas baseChart class="chart"
                    [colors]="attackerCountryChart.colors"
                    [chartType]="'pie'"
                    [data]="attackerCountryChart.data"
                    [labels]="attackerCountryChart.lables"></canvas>
          </div>
        </div>
      </div>
    </div>
    <!--end 12 cell-->
    <div class="col-lg-6">
      <div class="card">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.waf.ip_chart_top_10' | translate}}</span>

          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['ipChart'].value"
                        (changeValue)="periodFilterChart.controls['ipChart'].setValue($event);loadAttackerIpChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadAttackerIpChart()" [formControl]="periodFilterChart.controls['ipChart']"-->
                    <!--name="period" class="form-control"-->
                    <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodCharts" [ngValue]="period">-->
                <!--{{period.label}}-->
              <!--</option>-->
            <!--</select>-->
          </div>


        </div>
        <div class="card-body">
          <div class="chart-wrapper" *ngIf="attackerIpChart">
            <canvas baseChart class="chart"
                    [datasets]="attackerIpChart.data"
                    [labels]="attackerIpChart.labels"
                    [options]="barChartOptions"
                    [legend]="true"
                    [chartType]="'horizontalBar'"></canvas>
          </div>
        </div>
      </div>
    </div>
    <div class="col-lg-6">
      <div class="card">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.waf.attack_website_chart_top_10' | translate}}</span>

          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}} </span>
            <app-period [selectTime]="periodFilterChart.controls['attackWebsiteChart'].value"
                        (changeValue)="periodFilterChart.controls['attackWebsiteChart'].setValue($event);loadAttackerWebsiteChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadAttackerWebsiteChart()"-->
                    <!--[formControl]="periodFilterChart.controls['attackWebsiteChart']"-->
                    <!--name="period" class="form-control"-->
                    <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodCharts" [ngValue]="period">-->
                <!--{{period.label}}-->
              <!--</option>-->
            <!--</select>-->
          </div>


        </div>
        <div class="card-body">
          <div class="chart-wrapper" *ngIf="attackerWebsiteChart">
            <canvas baseChart class="chart"
                    [colors]="attackerWebsiteChart.colors"
                    [chartType]="'pie'"
                    [data]="attackerWebsiteChart.data"
                    [labels]="attackerWebsiteChart.lables"></canvas>
          </div>
        </div>
      </div>
    </div>
    <div class="col-lg-6">
      <div class="card">
        <div class="card-header d-flex align-items-center justify-content-between">
          <span>{{'monitor.waf.attack_action_chart_top_10' | translate}}</span>
          <div class="d-flex align-items-center">
            <span class="pr-1">{{'common.period' | translate}}</span>
            <app-period [selectTime]="periodFilterChart.controls['attackActionChart'].value"
                        (changeValue)="periodFilterChart.controls['attackActionChart'].setValue($event);loadAttackerActionChart()"
                        drop-type="right"
            >
            </app-period>
            <!--<select (change)="loadAttackerActionChart()" [formControl]="periodFilterChart.controls['attackActionChart']"-->
                    <!--name="period" class="form-control float-right"-->
                    <!--style="width: auto">-->
              <!--<option *ngFor=" let period of periodCharts" [ngValue]="period">-->
                <!--{{period.label}}-->
              <!--</option>-->
            <!--</select>-->
          </div>


        </div>
        <div class="card-body">
          <div class="chart-wrapper" *ngIf="attackerActionChart">
            <canvas baseChart class="chart"
                    [colors]="attackerActionChart.colors"
                    [chartType]="'pie'"
                    [data]="attackerActionChart.data"
                    [labels]="attackerActionChart.lables"></canvas>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!--end row -->
  <div class="row">

  </div>
  <!-- end row -->
  <div class="row">


    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          {{'monitor.waf.website_application_log' | translate}}
        </div>
        <div class="card-body" style="padding-bottom: 300px">

          <div class="row mb-2">
            <div class="col-8 mb-2 d-flex align-items-center">
              <button class="btn btn-primary" (click)="refreshSearchForm()">
                <i class="fa fa-refresh"></i>
                <span class="d-none d-md-inline">{{'common.refresh' | translate}}</span>
              </button>

              <a (click)="onDownload()" class="btn btn-primary ml-2" [ngClass]="monitorWafs.length <= 0? 'disabled' : ''">
                <i class="fa fa-download"></i>
                <span class="d-none d-md-inline">{{'common.download' | translate}}</span>
              </a>

              <div class="ml-2 mr-2">
                <i class="fa fa-calendar"></i>
                <span class="d-none d-md-inline">{{'common.period' | translate}}</span>
              </div>
              <app-period [selectTime]="dataFilterForm.controls['period'].value"
                          (changeValue)="dataFilterForm.controls['period'].setValue($event);loadAll()"
              >
              </app-period>
              <!--<select (change)="changePeriodFilterForm()" [formControl]="dataFilterForm.controls['period']"-->
                      <!--name="period" class="form-control float-left ml-2"-->
                      <!--style="width: auto">-->
                <!--<option *ngFor=" let period of periodFilterForms" [ngValue]="period">-->
                  <!--{{period.label}}-->
                <!--</option>-->
              <!--</select>-->

            </div>
            <div class="col-4 d-flex justify-content-end align-items-center">
              <span class="mr-1" style="line-height: 33px">{{'common.show' | translate}}</span>
              <select (change)="changeLimit()" [(ngModel)]="paging.limit" class="form-control"
                      style="width: auto">
                <option *ngFor="let limitElement of limits" value="{{limitElement.value}}">{{limitElement.label}}
                </option>
              </select>
            </div>


            <div class="col-12">
              <app-ng-mutifilter [fields]="fields" (filter)="onFilter($event)">

              </app-ng-mutifilter>
              <!--<div class="input-group float-left" style="max-width: 300px">-->
                <!--<div class="input-group-append">-->
                  <!--<button (click)="loadAll()" class="btn btn-dark" type="button">-->
                    <!--<i class="fa fa-filter"></i>-->
                  <!--</button>-->
                <!--</div>-->
                <!--<input [formControl]="dataFilterForm.controls['filter']" type="text" class="form-control"-->
                       <!--placeholder="{{'common.filter' | translate}}">-->

              <!--</div>-->
            </div>


          </div>

          <!--end row-->
          <table class="table table-bordered table-sort-icon" *ngIf="monitorWafs">
            <thead>
            <tr appSort [orderBy]="order.orderBy" [orderType]="order.orderType" (orderChange)="changeOder($event)">
              <th>{{'monitor.ddos.ordinal_numbers' | translate}}</th>
              <th appSortBy="attacker_ip">{{'monitor.ddos.ip_addr' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="datetime">{{'monitor.ddos.blocked_time' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="attacker_country">{{'monitor.ddos.country' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="group_rule">{{'monitor.ddos.rule' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th appSortBy="website_domain">{{'monitor.ddos.website_domain' | translate}}
                <fa-icon></fa-icon>
              </th>
              <th>{{'monitor.ddos.detail' | translate}}</th>
            </tr>
            </thead>
            <tbody *ngIf="monitorWafs && monitorWafs.length">
            <tr
              *ngFor="let monitorWaf of monitorWafs; index as i">
              <td class="text-center">{{i + paging.offset + 1}}</td>
              <td>{{monitorWaf.attacker_ip}}</td>
              <td class="text-center">{{monitorWaf.datetime}}</td>
              <td class="text-center">
                <span><i class="flag-icon flag-icon-{{monitorWaf.attacker_country.toLocaleLowerCase()}}"></i></span>
                {{showCountry(monitorWaf.attacker_country)}}

              </td>
              <td>{{monitorWaf.group_rule}}</td>
              <td>{{monitorWaf.website_domain}}</td>
              <td class="text-center">
                <span style="cursor: pointer" (click)="monitorWaf.is_show = !monitorWaf.is_show">
                  <i style="font-size: 20px"
                     [class]="monitorWaf.is_show? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i>
                </span>
                <div class="_tooltip tooltip__initiator text-left" *ngIf="monitorWaf.is_show">
                  <!-- view tooltip -->
                  <div class="tooltip__item">
                    <div class="row mb-2">
                      <div class="col-2 font-weight-bold">{{'common.time' | translate}}</div>
                      <div class="col-4">{{monitorWaf.datetime}}</div>
                      <div class="col-2 font-weight-bold">{{'common.ip_address' | translate}}</div>
                      <div class="col-4">{{monitorWaf.attacker_ip}}</div>
                    </div>
                    <div class="row mb-2">
                      <div class="col-2 font-weight-bold">{{'monitor.waf.group_rule' | translate}}</div>
                      <div class="col-4">{{monitorWaf.group_rule}}</div>
                      <div class="col-6">{{monitorWaf.matched_info}}</div>
                    </div>
                    <div class="row mb-2">
                      <div class="col-2 font-weight-bold">{{'monitor.waf.action' | translate}}</div>
                      <div class="col-4"></div>
                      <div class="col-2 font-weight-bold">{{'monitor.waf.host' | translate}}</div>
                      <div class="col-4">{{monitorWaf.website_domain}}</div>
                    </div>
                    <div class="row mb-2">
                      <div class="col-2 font-weight-bold">
                        Request Header
                      </div>
                      <div class="col-10">
                        <div>
                          <div class="w-25 d-inline font-weight-bold">{{'monitor.waf.request_url' | translate}} :</div>
                          <div class="w-75 d-inline">{{monitorWaf.request_header.request_url}}</div>
                        </div>
                        <div class="w-100 font-weight-bold">{{'monitor.waf.header' | translate}} :</div>
                        <div class="pl-3" *ngFor="let item of monitorWaf.request_header.headers | keyvalue">
                          <div class="w-100 pl-2 d-inline">{{item.key}} : {{item.value}}</div>
                        </div>

                      </div>
                    </div>
                  </div>


                </div>
              </td>
            </tr>
            </tbody>
          </table>

          <div class="row">
            <div class="col-12">

              <span *ngIf="monitorWafs.length !== 0" style="line-height: 33px" class="float-left">
                {{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + monitorWafs.length),
              total: paging.total
            } }}
              </span>
              <div *ngIf="!monitorWafs || monitorWafs.length === 0" class="text-center">
                <span>{{'common.no_record' | translate}}</span>
              </div>
              <ngb-pagination *ngIf="monitorWafs.length !== 0" class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)">
              </ngb-pagination>
            </div>

          </div>

        </div>
      </div>
    </div>

  </div>
</div>
